class TrialAppliesController < ApplicationController

  def create
    Users::ApplyTrailService.call(current_user, create_params)
    render_ok
  rescue Users::ApplyTrailService::Error => ex
    render_error(ex.message)
  end

  private

  def create_params
    params.permit(:phone, :code, :reason).merge(remote_ip: request.remote_ip)
  end
end
