class Users::ShixunsController < Users::BaseController
  def index
    shixuns = Users::ShixunService.new(observed_user, query_params).call

    @count = shixuns.count
    @shixuns = paginate(shixuns.includes(:first_tag_repertoire), special: true)
  end

  private

  def query_params
    params.permit(:category, :status, :sort_by, :sort_direction)
  end
end