json.top do
  json.shixun_url "/shixuns"
  json.shixun_paths_url "#{@old_domain}/paths"
  json.course_url "#{@old_domain}/courses"
  json.competitions_url "#{@old_domain}/competitions"
  json.topic_url "#{@old_domain}/forums"
  json.new_course_url "#{@old_domain}/courses/new"
  json.new_shixun_url "#{@old_domain}/shixuns/new"
  json.new_shixun_path_url "#{@old_domain}/paths/new"
  json.new_project_url "#{@old_domain}/projects/new"
  json.join_course_url "#{@old_domain}/courses/join_course_multi_role"
  json.join_project_url "#{@old_domain}/applied_project/applied_project_info"
  json.message_url "#{@user_url}/user_tidings"
  json.new_message @new_message

  json.career_url do
    json.array! @career.to_a do |c|
      if c[1].present?
        json.name c[1]
        json.url "#{@old_domain}/careers/#{c[0]}/introduction"
      end
    end
  end
  json.auth @auth

  json.avatar_url "#{@user_url}"
  json.my_course_url "#{@user_url}"
  json.my_shixun_url "#{@user_url}?type=a_shixun"
  json.my_shixun_paths_url "#{@user_url}?type=a_path"
  json.my_project_url "#{@user_url}?type=a_project"
  json.account_manager_url "#{@old_domain}/my/account"
  json.logout_url logout_accounts_path
  # 旧版的域名
  json.old_url @old_domain
end

json.down do
  json.web_root "#{@old_domain}"
  json.about_us "#{@old_domain}/help?index=1"
  json.connect_us "#{@old_domain}/help?index=2"
  json.cooperation_partner "#{@old_domain}/help?index=3"
  json.service_agreement "#{@old_domain}/help?index=4"
  json.help_center "#{@old_domain}/help?index=5"
  json.feedback "#{@old_domain}/help?index=6"
end

json.online_consult "https://shang.qq.com/wpa/qunwpa?idkey=2f2043d88c1bd61d182b98bf1e061c6185e23055bec832c07d8148fe11c5a6cd"

