import React, { Component } from 'react';
import { Redirect } from 'react-router';
import { getImageUrl, toPath } from 'educoder'
import PropTypes from 'prop-types';

class NewFooter extends Component {
  constructor(props) {
    super(props)

  }

  componentWillReceiveProps(newProps, newContext) {

  }


  render() {
    return (
      <div className="newFooter edu-txt-center newContainers">
        <div className="inner-footer_con">
          <div className="footercon">
            <div className="inline mt40 mb5">
              <a href="/" className="fl" style={{height:'70px'}}>
                <img alt="高校智能化教学与实训平台" src={getImageUrl(`images/educoder/headNavLogo.png?1526520218`)} width="70px">
                </img>
              </a>
              <span className="fl color-grey-c cdefault font-28 ml22" style={{lineHeight:'74px'}}>EduCoder.net</span>
            </div>
            <ul className="clearfix inner-footernav">
              <li><a href="/" className="fl" target="_blank">网站首页</a></li>
              <li><a href={this.props.Footerdown===undefined?"":this.props.Footerdown.about_us} className="fl" target="_blank">关于我们</a></li>
              <li><a href={this.props.Footerdown===undefined?"":this.props.Footerdown.connect_us} className="fl" target="_blank">联系我们</a></li>
              <li><a href={this.props.Footerdown===undefined?"":this.props.Footerdown.cooperation_partner} className="fl" target="_blank">合作伙伴</a></li>
              <li><a href={this.props.Footerdown===undefined?"":this.props.Footerdown.service_agreement} className="fl" target="_blank">服务协议</a></li>
              <li><a href={this.props.Footerdown===undefined?"":this.props.Footerdown.help_center} className="fl" target="_blank">帮助中心</a></li>
              <li><a href={this.props.Footerdown===undefined?"":this.props.Footerdown.feedback} className="fl" target="_blank">意见反馈</a></li>
            </ul>
          </div>
          <div>
            <p className="footer_con-p inline lineh-30 font-14"><span className="font-18 fl">©</span>&nbsp;2019&nbsp;EduCoder<span className="ml15 mr15">湘ICP备17009477号</span><a href="https://team.trustie.net" style={{"color":"#888"}} target="_blank">Trustie</a>&nbsp;&nbsp;&nbsp;&amp;&nbsp;&nbsp;&nbsp;IntelliDE inside.</p>
          </div>
          <div className="cl"></div>
        </div>
      </div>
    );
  }
}

export default NewFooter;
