import React, { Component } from 'react';
import { SnackbarHOC } from 'educoder';
import {BrowserRouter as Router,Route,Switch} from 'react-router-dom';
import {Tooltip,Menu,Pagination} from 'antd';
import Loadable from 'react-loadable';
import Loading from '../../../Loading';
import axios from 'axios';
import {getImageUrl} from 'educoder';
import { TPMIndexHOC } from '../../tpm/TPMIndexHOC';
import { CNotificationHOC } from '../../courses/common/CNotificationHOC'
import "./usersInfo.css"

class publicCreateNew extends Component{
  constructor(props){
    super(props);
  }
  render() {
    let {href,name,index}=this.props;
    return (
      <div className="square-Item" style={{"height":`${index=="2"?"298":index=="3"?"295":"289"}px`}}>
        <div className="substance substancepad">
          <a href={`${href}`}>
            <div className="substancenenew">
              <div className="leftten"></div>
              <div className="topten"></div>
            </div>
          </a>
        </div>
        <div className="edu-txt-center course-bottom">
          <div className="inline color-grey-6">
            <span className="fl ml10 mr10 squareIconSpan substancefont">
              {name}    
            </span>
          </div>
        </div>
      </div>
    )
  }
}
export default publicCreateNew;