class EcTrainingObjective < ApplicationRecord

  belongs_to :ec_year

  # 培养目标分项
  has_many :ec_training_subitems, dependent: :destroy

  validates :content, presence: true

  accepts_nested_attributes_for :ec_training_subitems, allow_destroy: true
end
