json.array! topics do |topic|
  task_private = course_identity > Course::STUDENT && !topic.is_public
  json.private_icon task_private
  json.(topic, :id, :name, :status)
  json.author topic.teacher.full_name
  json.user_topic_status topic.user_status(current_user)
  json.selected_count topic.student_graduation_topics.count
  json.confirmation_count topic.student_graduation_topics.confirmation_count
end